import org.w3c.dom.*;
import org.w3c.dom.traversal.*;
import org.xml.sax.SAXException;
import java.io.*; 
import org.apache.xml.serialize.*;
import javax.xml.parsers.*;
public class Traitements {
  // ne pas bouger les mthodes de traitement,  cause de l'inclusion 
  // ligne par ligne dans le fichier tex ! 
  // 
  public static void compteDisques(Document doc) {
    NodeList list=doc.getElementsByTagName("disque");
    System.out.println("Nombre de disques : "+list.getLength());
  }
  public static void titreDisques(Document doc) {
    NodeList list=doc.getElementsByTagName("titre");
    for(int i=0;i<list.getLength();i++) {
      NodeList texte=list.item(i).getChildNodes();
      System.out.print("Disque : ");
      for(int j=0;j<texte.getLength();j++) {
	System.out.print(texte.item(j).getNodeValue());
      }
      System.out.println();
    }
  }
  public static void titreDisques2(Document doc) {
    NodeList list=doc.getElementsByTagName("titre");
    for(int i=0;i<list.getLength();i++) {
      list.item(i).normalize();
      System.out.println("Disque : "+list.item(i).getFirstChild().getNodeValue());
    }
  }
  public static void afficheDisques(Document doc) {
    NodeList titres=doc.getElementsByTagName("titre");
    NodeList interprtes=doc.getElementsByTagName("interprte");
    for(int i=0;i<titres.getLength();i++) {
      Element titre=(Element)(titres.item(i));
      titre.normalize();
      System.out.print("Disque : "+titre.getFirstChild().getNodeValue());
      Element interprte=(Element)(interprtes.item(i));
      Element groupe=doc.getElementById(interprte.getAttribute("nom"));
      groupe.normalize();
      Node nom=groupe.getFirstChild();
      System.out.println(" interprt par "+nom.getFirstChild().getNodeValue());
    }
  }
  public static void afficheElements(Document doc) {
    DocumentTraversal docT=(DocumentTraversal)doc;
    NodeIterator iter=docT.createNodeIterator(doc.getDocumentElement(), 
					      NodeFilter.SHOW_ELEMENT,
					      null,true);
    Node node=iter.nextNode();
    while (node!=null) {
      System.out.println(node.getNodeName());
      node=iter.nextNode();
    }
  }
  public static void afficheCibles(Document doc) {
    DocumentTraversal docT=(DocumentTraversal)doc;
    NodeIterator iter=docT.createNodeIterator(doc.getDocumentElement(), 
					      NodeFilter.SHOW_ELEMENT,
					      new Cibles(),
					      true);
    Node node=iter.nextNode();
    while (node!=null) {
      Element cible=(Element)node;
      System.out.println(cible.getAttribute("name"));
      node=iter.nextNode();
    }
  }
  public static void save(Document doc,String file) {
    OutputFormat format=new OutputFormat(doc,"ISO-8859-1",true);
    try {
      OutputStream out=new FileOutputStream(file);
      XMLSerializer printer=new XMLSerializer(out,format);
      printer.serialize(doc);
    } catch(IOException ioe) {
      ioe.printStackTrace();
    }
  }
  public static Document load(String xmlFile,boolean validation) {
    DocumentBuilderFactory usine=null;
    try {
      usine=DocumentBuilderFactory.newInstance();
    } catch(FactoryConfigurationError e) {
      System.err.println("Impossible de crer l'usine : "+e);
      System.exit(1);
    }
    usine.setNamespaceAware(true);
    usine.setValidating(validation);
    usine.setIgnoringElementContentWhitespace(true);
    DocumentBuilder analyseur=null;
    try {
      analyseur=usine.newDocumentBuilder();
    } catch(ParserConfigurationException e) {
      System.err.println("Impossible de crer l'analyseur : "+e);
      System.exit(1);
    }
    analyseur.setErrorHandler(new PrintError());
    Document doc=null;
    try {
      doc=analyseur.parse(xmlFile);
    } catch(SAXException e) {
      System.err.println("Erreur d'analyse syntaxique : "+e);
      System.exit(1);
    } catch(IOException e) {
      System.err.println("Erreur de chargement du document : "+e);
      System.exit(1);
    }
    return doc;
  }
  public static void main(String[] args) {
    if(args.length<1 || args.length>2) {
      System.err.println("usage: Traitements [-valid] xmlfile");
      System.exit(1);
    }
    boolean validation=false;
    String xmlFile=args[0];     
    if(args.length==2) {
      if(!args[0].equals("-valid")) {
	System.err.println("usage: Traitements [-valid] xmlfile");
	System.exit(1);
      } else {
	validation=true;
	xmlFile=args[1];
      }
    }
    Document doc=load(xmlFile,validation);
    compteDisques(doc);
    titreDisques2(doc);
    afficheDisques(doc);
    afficheElements(doc);
    afficheCibles(doc);
    save(doc,"truc.xml");
  }
}

